import { ExecutionResult } from 'graphql';
import { ApolloLink } from 'apollo-link';
import { GraphQLSchema } from 'graphql';
export declare type Fetcher = (operation: {
    query: string;
    operationName?: string;
    variables?: {
        [key: string]: any;
    };
    context?: {
        [key: string]: any;
    };
}) => Promise<ExecutionResult>;
export declare const fetcherToLink: (fetcher: Fetcher) => ApolloLink;
export default function makeRemoteExecutableSchema({schema, link, fetcher}: {
    schema: GraphQLSchema;
    link?: ApolloLink;
    fetcher?: Fetcher;
}): GraphQLSchema;
